/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// duration - The maximum time in milliseconds to collect digits.    numOfDigits - The maximum number of digits to collect.    terminationDigit - A digit that will be used by the user to stop the digit collection.    clearDigitsBuffer - If true, the digits buffer is cleared before the get digit action starts.    waitForCompletion - If true, the http request will reply only when the recording will be completed, otherwise a webhook shall be used to be notified on completion.
    /// </summary>
    [DataContract]
        public partial class GetDigitsParams :  IEquatable<GetDigitsParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GetDigitsParams" /> class.
        /// </summary>
        /// <param name="duration">duration.</param>
        /// <param name="numOfDigits">numOfDigits.</param>
        /// <param name="terminationDigit">terminationDigit.</param>
        /// <param name="clearDigitsBuffer">clearDigitsBuffer.</param>
        /// <param name="waitForCompletion">waitForCompletion.</param>
        public GetDigitsParams(int? duration = default(int?), int? numOfDigits = default(int?), string terminationDigit = default(string), bool? clearDigitsBuffer = default(bool?), string? userContext = default(string?), bool? waitForCompletion = default(bool?))
        {
            this.Duration = duration;
            this.NumOfDigits = numOfDigits;
            this.TerminationDigit = terminationDigit;
            this.ClearDigitsBuffer = clearDigitsBuffer;
            this.UserContext = userContext;
            this.WaitForCompletion = waitForCompletion;
        }
        
        /// <summary>
        /// Gets or Sets Duration
        /// </summary>
        [DataMember(Name="duration", EmitDefaultValue=false)]
        public int? Duration { get; set; }

        /// <summary>
        /// Gets or Sets NumOfDigits
        /// </summary>
        [DataMember(Name="numOfDigits", EmitDefaultValue=false)]
        public int? NumOfDigits { get; set; }

        /// <summary>
        /// Gets or Sets TerminationDigit
        /// </summary>
        [DataMember(Name="terminationDigit", EmitDefaultValue=false)]
        public string TerminationDigit { get; set; }

        /// <summary>
        /// Gets or Sets ClearDigitsBuffer
        /// </summary>
        [DataMember(Name="clearDigitsBuffer", EmitDefaultValue=false)]
        public bool? ClearDigitsBuffer { get; set; }

        /// <summary>
        /// Gets or Sets UserContext
        /// </summary>
        [DataMember(Name = "userContext", EmitDefaultValue = false)]
        public string UserContext { get; set; }

        /// <summary>
        /// Gets or Sets WaitForCompletion
        /// </summary>
        [DataMember(Name="waitForCompletion", EmitDefaultValue=false)]
        public bool? WaitForCompletion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GetDigitsParams {\n");
            sb.Append("  Duration: ").Append(Duration).Append("\n");
            sb.Append("  NumOfDigits: ").Append(NumOfDigits).Append("\n");
            sb.Append("  TerminationDigit: ").Append(TerminationDigit).Append("\n");
            sb.Append("  ClearDigitsBuffer: ").Append(ClearDigitsBuffer).Append("\n");
            sb.Append("  UserContext: ").Append(UserContext).Append("\n");
            sb.Append("  WaitForCompletion: ").Append(WaitForCompletion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as GetDigitsParams);
        }

        /// <summary>
        /// Returns true if GetDigitsParams instances are equal
        /// </summary>
        /// <param name="input">Instance of GetDigitsParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GetDigitsParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Duration == input.Duration ||
                    (this.Duration != null &&
                    this.Duration.Equals(input.Duration))
                ) && 
                (
                    this.NumOfDigits == input.NumOfDigits ||
                    (this.NumOfDigits != null &&
                    this.NumOfDigits.Equals(input.NumOfDigits))
                ) && 
                (
                    this.TerminationDigit == input.TerminationDigit ||
                    (this.TerminationDigit != null &&
                    this.TerminationDigit.Equals(input.TerminationDigit))
                ) && 
                (
                    this.ClearDigitsBuffer == input.ClearDigitsBuffer ||
                    (this.ClearDigitsBuffer != null &&
                    this.ClearDigitsBuffer.Equals(input.ClearDigitsBuffer))
                ) && 
                (
                    this.WaitForCompletion == input.WaitForCompletion ||
                    (this.WaitForCompletion != null &&
                    this.WaitForCompletion.Equals(input.WaitForCompletion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Duration != null)
                    hashCode = hashCode * 59 + this.Duration.GetHashCode();
                if (this.NumOfDigits != null)
                    hashCode = hashCode * 59 + this.NumOfDigits.GetHashCode();
                if (this.TerminationDigit != null)
                    hashCode = hashCode * 59 + this.TerminationDigit.GetHashCode();
                if (this.ClearDigitsBuffer != null)
                    hashCode = hashCode * 59 + this.ClearDigitsBuffer.GetHashCode();
                if (this.WaitForCompletion != null)
                    hashCode = hashCode * 59 + this.WaitForCompletion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
